Imports System.Net.Mail

'
' Class to send emails, send "net send" messages and write to the eventlog
'
Class Alerts

#Region "API Region"
    'NET_API_STATUS NetMessageBufferSend(
    '  LPCWSTR servername,
    '  LPCWSTR msgname,
    '  LPCWSTR fromname,
    '  LPBYTE buf,
    '  DWORD buflen
    ');
    Private Declare Unicode Function NetMessageBufferSend Lib "NETAPI32.DLL" ( _
        ByVal Server As String, _
        ByVal ToPCName As String, _
        ByVal FromName As String, _
        ByVal Msg As String, _
        ByVal lSize As Integer _
    ) As Integer
#End Region

    '
    ' Send an email to a list of users
    '
    Sub SendEmail(ByVal Emails() As String, ByVal TableName As String, ByVal buf As String)
        Dim mailClient As SmtpClient
        Dim Email As String

        mailClient = New SmtpClient(My.Settings.SMTP_Server)

        For Each Email In Emails
            ' must have a valid From address to get past our spam filters
            Dim Message As New MailMessage(My.Settings.Sender, Email)

            Message.Subject = "SOSOS Alert (" & TableName & ")"
            Message.Body = "New SOSOS entry in the '" & TableName & "' table" & vbCrLf & vbCrLf & buf

            mailClient.Send(Message)
        Next

    End Sub

    '
    ' Send a popup message to a list of PCs
    '
    Sub SendMessage(ByVal PCNames() As String, ByVal TableName As String)
        Dim PCName As String
        Dim Msg As String

        For Each PCName In PCNames
            Msg = "New SOSOS entry in the '" & TableName & "' table" & vbNullChar
            ' must have a valid "from" Name to work
            NetMessageBufferSend("", PCName, Environment.MachineName, Msg, Len(Msg) * 2)
        Next
    End Sub

    '
    ' Write to the eventlog
    '
    Sub SendEventLog(ByVal TableName As String)
        Dim el As New EventLog
        el.Source = "AlertSOSOS"
        el.WriteEntry("New SOSOS entry in the '" & TableName & "' table", EventLogEntryType.Information)
    End Sub
End Class
